//
//  HomeDetailViewController.swift
//  UpaxMovie
//
//  Created Imo on 29/02/24.
//  Template generated by UPAX Zeus
//

import UIKit

class HomeDetailViewController: UIViewController {
	var presenter: HomeDetailPresenterProtocol?
    
    // MARK: - Private properties
    /// Views for this controller
    public let views = HomeDetailViewControllerViews()
    
    var data: MovieResponse?
    var item: Movie?

	override func viewDidLoad() {
        super.viewDidLoad()
        setupLayout()
        configViews()
        callEndpoint(item?.id ?? 0)
    }
    
    func configViews() {
        title = "Movie Info"
        views.tableView.dataSource = self
        views.tableView.delegate = self
    }
    
    func callEndpoint(_ movieId: Int) {
        presenter?.movieRecommendations(1, movieId: movieId) { [weak self] data in
            self?.data = data
            DispatchQueue.main.async {
                self?.views.tableView.reloadData()
            }
        }
    }
    
    func loadMore() {
        if (data?.page ?? 1) >= (data?.total_pages ?? 0) {
            return
        }
        
        data?.page += 1
        presenter?.movieRecommendations(data?.page ?? 1, movieId: item?.id ?? 0) { [weak self] data in

            var indexPaths: [IndexPath] = []
            let rangeStart = self?.data?.results?.count ?? 0
            let rangeEnd = rangeStart + ((data?.results?.count ?? 0) - 1)
            for i in rangeStart...rangeEnd {
                indexPaths.append(IndexPath(row: i, section: 0))
            }

            self?.data?.results?.append(contentsOf: data?.results ?? [])
            self?.data?.page = data?.page ?? 1
            self?.data?.total_pages = data?.total_pages ?? 1
            
            DispatchQueue.main.async {
                self?.views.tableView.insertRows(at: indexPaths, with: .none)
            }
        }
    }
}

extension HomeDetailViewController: HomeDetailViewProtocol {
    
}
